#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Mar 12 16:56:39 2019

@author: gilles
"""

###############
# Exercice 1 #
##############

""" Fonction termeSyracuse(u : entier;u : entier)
u : un terme de la suite de Syracuse
renvoir le terme suivant dans la suite de Syracuse """

def termeSyracuse(u):
    if u%2==0:
            u=u//2
    else:
            u=3*u+1
    return u
    
""" Fonction syracuse(n,u0 : entiers ; u :entier)
n : rang du terme cherché
u0 : premier terme de la suite
renvoie u le terme de rang n de la suite de Syracuse """

def syracuse(n,u0):
    u=u0
    for i in range(1,n+1):
        u=termeSyracuse(u)
    return u

""" Fonction tempsDeVol(u0 : entiers ; n :entier)
u0 : premier terme de la suite
renvoie n le plus petit indice tel que u=1 pour la suite de Syracuse """

def tempsDeVol(u0):
    u=u0
    n=0
    while u!=1:
        n=n+1
        u=termeSyracuse(u)
    return n

""" Fonction tempsVolAltitude(u0 : entiers ; n :entier)
u0 : premier terme de la suite
renvoie n le plus petit indice tel que u<=u0 pour la suite de Syracuse """

def tempsVolAltitude(u0):
    u=u0
    n=0
    u=termeSyracuse(u)
    while u>u0:
        n=n+1
        u=termeSyracuse(u)
    return n

""" Fonction altitudeMaximale(u0 : entiers ; maxi :entier)
u0 : premier terme de la suite
renvoie maxi la plus grande valeur de la suite de syracuse"""

def altitudeMaximale(u0):
    u=u0
    maxi=u0
    while u!=1:
        u=termeSyracuse(u)
        if u>maxi:
            maxi=u
    return maxi

###############
# Exercice 2 #
#############
    

""" Fonction sommeDiviseurs(n : entier;somme : entier)
n : nombre dont on veut la somme des diviseurs
i : entier, position courante dans l'ensemble des entiers compris entre 1 et n
renvoie somme, la somme des diviseurs de n """

def sommeDiviseurs(n):
    somme=0
    for i in range(1,n+1):
        if n%i==0:
           somme=somme+i
    return somme

""" Fonction parfait(n : entier; chaîne)
n : nombre dont on veut connaître la nature
som : entier, somme des diviseurs de n, strictement inférieurs à n
renvoie "déficient", "abondant" ou "parfait" selon la nature de n """

def parfait(n):
    som=sommeDiviseurs(n)-n
    if som<n:
        return "déficient"
    else:
        if som>n:
            return "abondant"
        else:
            return "parfait"
        
""" Fonction nombresParfaits(n : entier;)
i : entier, position courante dans l'ensemble des entiers compris entre 1 et n
som : entier, somme des diviseurs de i, strictement inférieurs à i
affiche les nombres parfaits compris entre 1 et n """

def nombresParfaits(n):
    for i in range(1,n+1):
        som=sommeDiviseurs(i)-i
        if som==i:
            print(i)


###############
# Exercice 3 #
#############
            
from random import randint

""" Fonction somme3dès(;somme : entier)
de1, de2, de3 : entiers, aléatoires entre 1 et 6
renvoie somme, la somme de trois dés """

def somme3dès():
    de1=randint(1,6)
    de2=randint(1,6)
    de3=randint(1,6)
    somme=de1+de2+de3
    return somme

""" Fonction toscane(n : entier; f9, f10 : flottants)
n : nombre de lancers de dés
n9 : entier, nombre de 9 sur n lancers
n10 : entier, nombre de 9 sur n lancers
de1, de2, de3 : entiers, entiers aléatoires entre 1 et 6 simulant trois dés
somme : entier, somme des trois dés
renvoie f9 et f10, les fréquences respectives du 9 et du 10 sur n lancers"""

def toscane(n) :
    n9=0
    n10=0
    for i in range(n) :
          de1=randint(1,6)
          de2=randint(1,6)
          de3=randint(1,6)
          somme=de1+de2+de3
          if somme == 9 :
              n9=n9+1
          if somme==10 :
              n10=n10+1
    f9=n9/n
    f10=n10/n
    return f9,f10